package sexpression

import recursion.TailCall

import recursion.TailCalls.done
import recursion.TailCalls.tailCall

@DisplayName("list")
open class Cons(open var first: SExpression, open var rest: SExpression) : SExpression(), Iterable<Cons> {

    override val isCons = true

    override fun toString(): String {
        return toStringTailRecursive(StringBuilder("(")).invoke()
    }

    private fun toStringTailRecursive(leadingString: StringBuilder): TailCall<String> {
        leadingString.append(first.toString())

        if (rest.isNull)
            return done(leadingString.append(")").toString())
        else if (rest.isCons) {
            return tailCall { (rest as Cons).toStringTailRecursive(leadingString.append(" ")) }
        }

        return done(leadingString.append(" . " + rest.toString() + ")").toString())
    }

    override fun iterator(): Iterator<Cons> = ConsIterator(this)

    private class ConsIterator(start: Cons) : Iterator<Cons> {

        private var current: SExpression = start

        override fun hasNext() = current.isCons
        override fun next() = (current as Cons).apply { current = rest }
    }
}
